var bco33000_gestaoFluxoCaixa_Controller = function(ScreenService, General, templateManager, ZHPromise, restEngine, ZhFilterPreferences){

    this.alteraEdicaoEFiltroContaCorrente = function(filtro){
        var gestaoFluxoCaixa = templateManager.container.getWidget('gestaoFluxoCaixa');
        
        var empresa = filtro.getField('CDEMPRESA').value();
        
        if (empresa)
            if (empresa.length > 0){
                empresa = empresa.join('_');
            }else empresa = null;
        
        var dtsdoccorr = filtro.getField('DTSDOCCORR');
        var dataInicial = dtsdoccorr.value()?dtsdoccorr.value().start:dtsdoccorr.value();
        var cdreducont = filtro.getField('CDREDUCONT');
        
        cdreducont.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDEMPRESA': filtro.value = (empresa) ? empresa : 'T';
                    break;
                case 'DTSDOCCORR': filtro.value = (dataInicial) ? dataInicial : null;
                    break;
            }
        });
        
        if (dataInicial && empresa){
            cdreducont.readOnly = false;
        }else{
            cdreducont.readOnly = true;
            cdreducont.setValue('');
        }
        
        cdreducont.reload();
    };

    this.preencheValoresStripe = function(widget, preference){
        var saldoTotal = this.somaSaldoContas(preference.FILTER_ROW);
        var contas = preference.FILTER_ROW.CDREDUCONT.join(' - ');
        var stripe = templateManager.container.getWidget('stripe');
        var qtdeEmpresas = null;
        if (preference.FILTER_ROW.CDEMPRESA){
            qtdeEmpresas = preference.FILTER_ROW.CDEMPRESA.length;
        }
        var empresas = '';
        for(var i = 0; qtdeEmpresas > i; i++){
            empresas = empresas + preference.FILTER_ROW.CDEMPRESA[i] + ' ' + preference.FILTER_ROW.NMEMPRESA[i];
            if (qtdeEmpresas - 1 != i)
                empresas = empresas + ' - ';
        }
        stripe.currentRow.EMPRESA = (empresas) ? empresas : 'Todos';
        stripe.currentRow.DTINICIAL = preference.FILTER_ROW.DTSDOCCORR.start;
        stripe.currentRow.DTFINAL = preference.FILTER_ROW.DTSDOCCORR.end;
        stripe.currentRow.SALDOTOTAL = saldoTotal;
        stripe.currentRow.CONTAS = contas;
    };

    this.somaSaldoContas = function(filtro){
        var soma = 0;
        filtro.VRSDOCCORR.forEach(function(data){
            soma = parseFloat((parseFloat(soma.toFixed(2)) + parseFloat(data.toFixed(2))).toFixed(2));
        });
        return soma;
    };

    /*this.validaContaCorrente = function(){
        var gestaoFluxoCaixa = templateManager.container.getWidget('gestaoFluxoCaixa');
        var filtro = gestaoFluxoCaixa.__filterPopup;
        if (filtro.getField('DTINICIAL').value()){
            filtro.getField('DSCONTCORR').readOnly = true;
        }else{
            filtro.getField('DSCONTCORR').readOnly = false;
        }
    };*/

    this.preparaFiltro = function(){
        var gestaoFluxoCaixa = templateManager.container.getWidget('gestaoFluxoCaixa');
        var dataAtual = moment().format('DD/MM/YYYY');
        var filterRow = {
            'DTSDOCCORR': {start : dataAtual, end : dataAtual},
            'CONSIDVENCSCC': 'N'
        };
        ZhFilterPreferences.setOriginalFilter(gestaoFluxoCaixa.id, filterRow);
        ZhFilterPreferences.openFilterWidget(gestaoFluxoCaixa, filterRow);
    };

    this.preparaFiltroFluxoCaixa = function(preference){
        var gestaoFluxoCaixa = templateManager.container.getWidget('gestaoFluxoCaixa');
        var filtro = preference.FILTER_ROW;
        var cdempresa = null;
        var cdreducont = null;
        var dataInicial = null;
        var dataFinal = null;
        if (filtro.hasOwnProperty('CDEMPRESA')){
            if (filtro.CDEMPRESA.length > 0){
                cdempresa = filtro.CDEMPRESA.join('_');
            }
        }
        if (filtro.hasOwnProperty('CDREDUCONT')){
            if (filtro.CDREDUCONT.length > 0){
                cdreducont = filtro.CDREDUCONT.join('_');
            }
        }
        if (filtro.hasOwnProperty('DTSDOCCORR')){
            if (filtro.DTSDOCCORR.hasOwnProperty('start') && filtro.DTSDOCCORR.start){
                dataInicial = filtro.DTSDOCCORR.start;
                dataFinal   = filtro.DTSDOCCORR.end;
            }
        }
        var posData = null;
        var i = 0;
        gestaoFluxoCaixa.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = (cdempresa) ? cdempresa : 'T';
                    break;
                ///case 'CDREDUCONT': filter.value = (cdreducont) ? cdreducont : 'T';
                    //break;
                case 'DTINICIAL': filter.value = (dataInicial) ? dataInicial : null;
                    break;
                case 'DTFINAL': filter.value = (dataFinal) ? dataFinal : null;
                    break;
                case 'DTSDOCCORR': posData = i;
                    break;
            }
            i++;
        });
        if (posData)
            gestaoFluxoCaixa.dataSourceFilter.splice(posData, 1);
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        preference.CUSTOM_FILTER_ROW.CDEMPRESA = cdempresa;
        preference.CUSTOM_FILTER_ROW.CDREDUCONT = cdreducont;
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('DTSDOCCORR')){
            delete preference.CUSTOM_FILTER_ROW.DTSDOCCORR;
        } 
    };

    this.preparaFiltroOrigemFluxoCaixa = function(widget){
        var gestaoFluxoCaixa = templateManager.container.getWidget('gestaoFluxoCaixa');
        var filtro = gestaoFluxoCaixa.appliedFilter;
        var empresa = null;
        if (filtro.FILTER_ROW.hasOwnProperty('CDEMPRESA')){
            if (filtro.FILTER_ROW.CDEMPRESA.value().length > 0){
                empresa = empresa.join('_');
            }
        }
        var cdreducont = filtro.FILTER_ROW.CDREDUCONT;
        var dtsdoccorr = gestaoFluxoCaixa.getField('DATAFLUXO').value();
        var considvencscc = filtro.FILTER_ROW.CONSIDVENCSCC;
        widget.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = (empresa) ? empresa : 'T';
                    break;
                case 'CDREDUCONT': filter.value = (cdreducont) ? cdreducont.join('_') : 'T';
                    break;
                case 'DATA': filter.value = dtsdoccorr;
                    break;
                case 'CONSIDVENCSCC': filter.value = considvencscc;
                    break;

            }
        });
    };

    this.getColumnName = function(field){
        var gestaoFluxoCaixa = field.widget;
        gestaoFluxoCaixa.ORIGEMFLUXO = field.name;
    };

    this.abrirDadosPorOrigem = function(gestaoFluxoCaixa){
        var dataFluxo = gestaoFluxoCaixa.currentRow.DATAFLUXO;
        var titulosReceber = ['VRRECEBER', 'VRRECPREV', 'VRRECEFET'];
        var titulosPagar = ['VRPAGAR', 'VRPAGPREV', 'VRPAGEFET'];
        var movimentacoes = ['VRCREDITO', 'VRDEBITO'];
        if (gestaoFluxoCaixa.ORIGEMFLUXO){
            if (gestaoFluxoCaixa.getField(gestaoFluxoCaixa.ORIGEMFLUXO).value() != 0){
                if (titulosReceber.indexOf(gestaoFluxoCaixa.ORIGEMFLUXO) != '-1'){
                    this.openSwipeTitulosReceber(gestaoFluxoCaixa);
                }else if (titulosPagar.indexOf(gestaoFluxoCaixa.ORIGEMFLUXO) != '-1'){
                    this.openSwipeTitulosPagar(gestaoFluxoCaixa);
                }else if (movimentacoes.indexOf(gestaoFluxoCaixa.ORIGEMFLUXO) != '-1'){
                    this.openSwipeMovimentacoes(gestaoFluxoCaixa);
                }
            }
        }
    };

    this.openSwipeTitulosReceber = function(gestaoFluxoCaixa){
        var titulosReceber = templateManager.container.getWidget('titulosReceber');
        if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRRECEBER'){
            titulosReceber.dataSourceFilter.push({"name": "CDREDUCONT","operator": "=","value": ""});
            titulosReceber.dataSourceFilter.push({"name": "CONSIDVENCSCC","operator": "=","value": ""});
            titulosReceber.label = 'Títulos a Receber Abertos';
            titulosReceber.dataSource.name = 'fin_movimentacaoBancaria#/crud/boletreceber_fluxoCaixaTitulosAbertos';
        }else if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRRECPREV'){
            titulosReceber.getField('CONTACORRENTE').isVisible = false;
            titulosReceber.getField('CONTACORRENTE').grouped = false;
            titulosReceber.getField('CLASSIFICACAO').isVisible = false;
            titulosReceber.getField('CLASSIFICACAO').grouped = false;
            titulosReceber.getField('VALOR').expression = "";
            titulosReceber.label = 'Títulos a Receber Previstos';
            titulosReceber.dataSource.name = 'fin_movimentacaoBancaria#/crud/boletreceber_fluxoCaixaTitulosPrevistos';
        }else if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRRECEFET'){
            titulosReceber.dataSourceFilter.push({"name": "CDREDUCONT","operator": "=","value": ""});
            titulosReceber.label = 'Títulos a Receber Efetivados';
            titulosReceber.dataSource.name = 'fin_movimentacaoBancaria#/crud/boletreceber_fluxoCaixaTitulosEfetivados';
        }
        this.preparaFiltroOrigemFluxoCaixa(titulosReceber);
        ScreenService.openSwipe(titulosReceber.parent)
        .then(function(){
            titulosReceber.reload();
        })
        .catch(function(erro){
            ScreenService.showMessage(erro.data.error);
        });
    };

    this.voltar = function(widget, dataSourceAberto, dataSourceEfetivado, dataSourcePrevisto){
        var dataSourceTitulosAbertos = 'fin_movimentacaoBancaria#/crud/' + dataSourceAberto;
        var dataSourceTitulosEfetivados = 'fin_movimentacaoBancaria#/crud/' + dataSourceEfetivado;
        var dataSourceTitulosPrevistos = 'fin_movimentacaoBancaria#/crud/' + dataSourcePrevisto;
        var indices = [];
        var i = 0;
        if (widget.dataSource.name == dataSourceTitulosAbertos){
            widget.dataSourceFilter.forEach(function(filtro){
                if (filtro.name == 'CDREDUCONT'){
                    indices.push(i);
                }else if (filtro.name == 'CONSIDVENCSCC'){
                    indices.push(i);
                }
                i++;
            });
            this.deleteFiltro(widget, indices);
        }
        if (widget.dataSource.name == dataSourceTitulosEfetivados){
            widget.dataSourceFilter.forEach(function(filtro){
                if (filtro.name == 'CDREDUCONT'){
                    indices.push(i);
                }
                i++;
            });
            this.deleteFiltro(widget, indices);
        }
        if (widget.dataSource.name == dataSourceTitulosPrevistos){
            widget.getField('CONTACORRENTE').isVisible = true;
            widget.getField('CONTACORRENTE').grouped = true;
            widget.getField('CLASSIFICACAO').isVisible = true;
            widget.getField('CLASSIFICACAO').grouped = true;
            widget.getField('VALOR').expression = "SUM";
        }
        widget.dataSource.data = [];
        General.widgetGoBackToList(widget);
    };

    this.deleteFiltro = function(widget, indices){
        for (var i = indices.length - 1; i >= 0; i--){
            widget.dataSourceFilter.splice(indices[i], 1);
        }
    };

    this.openSwipeTitulosPagar = function(gestaoFluxoCaixa){
        var titulosPagar = templateManager.container.getWidget('titulosPagar');
        if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRPAGAR'){
            titulosPagar.dataSourceFilter.push({"name": "CDREDUCONT","operator": "=","value": ""});
            titulosPagar.dataSourceFilter.push({"name": "CONSIDVENCSCC","operator": "=","value": ""});
            titulosPagar.label = 'Títulos a Pagar Abertos';
            titulosPagar.dataSource.name = 'fin_movimentacaoBancaria#/crud/boletpagar_fluxoCaixaTitulosAbertos';
        }else if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRPAGPREV'){
            titulosPagar.getField('CONTACORRENTE').isVisible = false;
            titulosPagar.getField('CONTACORRENTE').grouped = false;
            titulosPagar.getField('CLASSIFICACAO').isVisible = false;
            titulosPagar.getField('CLASSIFICACAO').grouped = false;
            titulosPagar.getField('VALOR').expression = "";
            titulosPagar.label = 'Títulos a Pagar Previstos';
            titulosPagar.dataSource.name = 'fin_movimentacaoBancaria#/crud/boletpagar_fluxoCaixaTitulosPrevistos';
        }else if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRPAGEFET'){
            titulosPagar.dataSourceFilter.push({"name": "CDREDUCONT","operator": "=","value": ""});
            titulosPagar.label = 'Títulos a Pagar Efetivados';
            titulosPagar.dataSource.name = 'fin_movimentacaoBancaria#/crud/boletpagar_fluxoCaixaTitulosEfetivados';
        }
        this.preparaFiltroOrigemFluxoCaixa(titulosPagar);
        ScreenService.openSwipe(titulosPagar.parent)
        .then(function(){
            titulosPagar.reload();
        })
        .catch(function(erro){
            ScreenService.showMessage(erro.data.error);
        });
    };

    this.openSwipeMovimentacoes = function(gestaoFluxoCaixa){
        var movimentacoes = templateManager.container.getWidget('movimentacoes');
        if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRCREDITO'){
            movimentacoes.label = 'Movimentações de Crédito';
            movimentacoes.dataSource.name = 'fin_movimentacaoBancaria#/crud/movbancario_fluxoCaixaMovimentosCredito';
        }else if (gestaoFluxoCaixa.ORIGEMFLUXO == 'VRDEBITO'){
            movimentacoes.label = 'Movimentações de Débito';
            movimentacoes.dataSource.name = 'fin_movimentacaoBancaria#/crud/movbancario_fluxoCaixaMovimentosDebito';
        }
        this.preparaFiltroOrigemFluxoCaixa(movimentacoes);
        ScreenService.openSwipe(movimentacoes.parent)
        .then(function(){
            movimentacoes.reload().then(function(){
                /*this.atualizarWidget(movimentacoes).then(function(){
                    movimentacoes.groupedData.forEach(function(group){
                        group.__groupOpened = false;
                    });
                }.bind(this));*/
            }.bind(this));
        }.bind(this))
        .catch(function(erro){
            ScreenService.showMessage(erro.data.error);
        });
    };

    this.atualizarWidget = function(movimentacoes){
        var deferred = ZHPromise.defer();
        movimentacoes.redraw();
        deferred.resolve();
        return deferred.promise;
    };

    this.calculaSaldoDiaEAcumulado = function(widget){
        var gestaoFluxoCaixa = templateManager.container.getWidget('gestaoFluxoCaixa');
        var saldoTotalContas = this.somaSaldoContas(gestaoFluxoCaixa.appliedFilter.FILTER_ROW);
        var saldoAnterior = saldoTotalContas;
        var saldoAnteriorReal = saldoTotalContas;
        var saldoDia = 0;
        var saldoDiaReal = 0;
        var acumulativo = 0;
        var acumulativoReal = 0;
        widget.dataSource.data.forEach(function(data){
            saldoDiaReal = parseFloat(((data.VRRECEFET + data.VRCREDITO) - (data.VRPAGEFET + data.VRDEBITO)).toFixed(2));
            saldoDia = parseFloat(((data.VRRECEBER + data.VRRECPREV + data.VRRECEFET + data.VRCREDITO) - (data.VRPAGAR + data.VRPAGPREV + data.VRPAGEFET + data.VRDEBITO)).toFixed(2));
            acumulativo = parseFloat((saldoAnterior + saldoDia).toFixed(2));
            acumulativoReal = parseFloat((saldoAnteriorReal + saldoDiaReal).toFixed(2));
            data.SALDODIA = saldoDia;
            data.SALDODIAREAL = saldoDiaReal;
            data.ACUMULATIVO = acumulativo;
            data.ACUMULATIVOREAL = acumulativoReal;
            saldoAnterior = acumulativo;
            saldoAnteriorReal = acumulativoReal;
        });
    };
    
    this.executaEvolucaoFluxoCaixa = function(widget) {
        if(widget.isValid()){
            General.callRestEngine('fin#/evolucaoFluxoCaixa', 'Row', widget.currentRow).then(function (result) {
                ScreenService.closePopup();
                ScreenService.showMessage('Evolução de fluxo de caixa efetuada com sucesso.');
            }).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            });
        }
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('bco33000_gestaoFluxoCaixa_Controller', bco33000_gestaoFluxoCaixa_Controller);
});